## ros-iron-v4l2-camera 0.6.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(v4l2_camera)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(ament_cmake_ros REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(camera_info_manager REQUIRED)
find_package(cv_bridge REQUIRED)
find_package(image_transport REQUIRED)

add_library(v4l2_camera
  src/v4l2_camera.cpp
  src/v4l2_camera_device.cpp)
rclcpp_components_register_nodes(v4l2_camera "v4l2_camera::V4L2Camera")

target_include_directories(v4l2_camera PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)

ament_target_dependencies(v4l2_camera
  "rclcpp"
  "rclcpp_components"
  "camera_info_manager"
  "cv_bridge"
  "image_transport")

target_compile_options(v4l2_camera PRIVATE -Werror)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(v4l2_camera PRIVATE "V4L2_CAMERA_BUILDING_LIBRARY")

install(
  DIRECTORY include/
  DESTINATION include
)
install(
  TARGETS v4l2_camera
  EXPORT export_${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

add_executable(v4l2_camera_node src/v4l2_camera_node.cpp)
target_include_directories(v4l2_camera_node PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(v4l2_camera_node v4l2_camera)
target_compile_options(v4l2_camera_node PRIVATE -Werror)

add_executable(v4l2_camera_compose_test src/v4l2_camera_compose_test.cpp)
target_include_directories(v4l2_camera_compose_test PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(v4l2_camera_compose_test v4l2_camera)
target_compile_options(v4l2_camera_compose_test PRIVATE -Werror)

install(TARGETS v4l2_camera_node v4l2_camera_compose_test
  EXPORT export_${PROJECT_NAME}
  DESTINATION lib/${PROJECT_NAME})

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  set(ament_cmake_copyright_FOUND TRUE)
  ament_lint_auto_find_test_dependencies()
endif()

ament_export_include_directories(
  include
)
ament_export_targets(
  export_${PROJECT_NAME}
)
ament_export_libraries(
  v4l2_camera
)

ament_export_dependencies(
  "camera_info_manager"
)

ament_package()

=== debian/changelog ===
ros-iron-v4l2-camera (0.6.1-3jammy) jammy; urgency=high

  * Rename include to resolve deprecation warning.
  * Contributors: Sander G. van Dijk, Steven! Ragnarök

 -- Sander G. van Dijk <sgvandijk@gmail.com>  Fri, 07 Oct 2022 16:00:00 -0000

ros-iron-v4l2-camera (0.6.0-3jammy) jammy; urgency=high

  * Use cv_bridge to perform conversions
  * Fix: Image topic should be image_raw, not raw_image, in README.md
  * Fix: Properly declare camera_info_url parameter
  * Contributors: Marcus M. Scheunemann, Sander G. van Dijk, ijnek

 -- Sander G. van Dijk <sgvandijk@gmail.com>  Sat, 03 Sep 2022 16:00:00 -0000

ros-iron-v4l2-camera (0.5.0-3jammy) jammy; urgency=high

  * Add time_per_frame parameter to adjust frame rate
  * Fix: use 64 bit integers to store control valueas and ranges
  * Contributors: Marcus M. Scheunemann, Sander G. van Dijk

 -- Sander G. van Dijk <sgvandijk@gmail.com>  Fri, 05 Aug 2022 16:00:00 -0000

ros-iron-v4l2-camera (0.4.0-3jammy) jammy; urgency=high

  * Read-only parameters as now properly marked as such
  * Use C-style strings for logging macros to adapt to new formatting constraints
    See: https://index.ros.org/doc/ros2/Releases/Release-Galactic-Geochelone/#change-in-rclcpp-s-logging-macros
  * Add support monochrome cameras
  * Contributors: Chris Lalancette, Sander G. van Dijk, nfry321

 -- Sander G. van Dijk <sgvandijk@gmail.com>  Thu, 28 Jan 2021 16:00:00 -0000

ros-iron-v4l2-camera (0.3.1-3jammy) jammy; urgency=high

  * Handle non discrete frame sizes; fixes support for Raspberry Pi + Camera Module
  * Contributors: Sander G. van Dijk

 -- Sander G. van Dijk <sgvandijk@gmail.com>  Fri, 06 Nov 2020 16:00:00 -0000

ros-iron-v4l2-camera (0.3.0-3jammy) jammy; urgency=high

  * Publishing is done on private topics to enable remapping of the namespace
  * CameraInfo is published in intra-process communication mode
  * Added parameter descriptions
  * Contributors: Christian Rauch, Marcus M. Scheunemann, Sander G. van Dijk

 -- Sander G. van Dijk <sgvandijk@gmail.com>  Fri, 25 Sep 2020 16:00:00 -0000

ros-iron-v4l2-camera (0.2.1-3jammy) jammy; urgency=high

  * Hold reference to parameters callback handle
  * Contributors: Jacob Perron

 -- Sander G. van Dijk <sgvandijk@gmail.com>  Wed, 05 Aug 2020 16:00:00 -0000

ros-iron-v4l2-camera (0.2.0-3jammy) jammy; urgency=high

  * Set frame_id on published images, default to "camera"
  * Output FOURCC code of available formats
  * Add parameter for setting the pixel format
    Default to using YUYV
  * Contributors: Sander G. van Dijk

 -- Sander G. van Dijk <sgvandijk@gmail.com>  Fri, 12 Jun 2020 16:00:00 -0000

ros-iron-v4l2-camera (0.1.1-3jammy) jammy; urgency=high

  * Add missing rclcpp_components build dependency
  * Contributors: Sander G. van Dijk

 -- Sander G. van Dijk <sgvandijk@gmail.com>  Sun, 11 Aug 2019 16:00:00 -0000

ros-iron-v4l2-camera (0.1.0-3jammy) jammy; urgency=high



 -- Sander G. van Dijk <sgvandijk@gmail.com>  Sat, 10 Aug 2019 16:00:00 -0000

=== debian/control ===
Source: ros-iron-v4l2-camera
Section: misc
Priority: optional
Maintainer: Sander G. van Dijk <sgvandijk@gmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-iron-ament-cmake-ros, ros-iron-ament-lint-auto <!nocheck>, ros-iron-ament-lint-common <!nocheck>, ros-iron-camera-info-manager, ros-iron-cv-bridge, ros-iron-image-transport, ros-iron-rclcpp, ros-iron-rclcpp-components, ros-iron-sensor-msgs, ros-iron-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-iron-v4l2-camera
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-iron-camera-info-manager, ros-iron-cv-bridge, ros-iron-image-transport, ros-iron-rclcpp, ros-iron-rclcpp-components, ros-iron-sensor-msgs, ros-iron-ros-workspace
Description: A ROS 2 camera driver using Video4Linux2

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/iron/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/iron" \
		-DAMENT_PREFIX_PATH="/opt/ros/iron" \
		-DCMAKE_PREFIX_PATH="/opt/ros/iron" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-iron-v4l2-camera//opt/ros/iron/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/iron/setup.sh" ]; then . "/opt/ros/iron/setup.sh"; fi && \
	dh_auto_install
